org.eclipse.viatra.cep.core.metamodels.derived

## Class TrapStateMatcher

- java.lang.Object
- - org.eclipse.viatra.query.runtime.internal.apiimpl.QueryResultWrapper
  - - org.eclipse.viatra.query.runtime.api.impl.BaseMatcher<TrapStateMatch>
    - - org.eclipse.viatra.cep.core.metamodels.derived.TrapStateMatcher

- All Implemented Interfaces:
    ViatraQueryMatcher<TrapStateMatch>

      public class TrapStateMatcher
      extends BaseMatcher<TrapStateMatch>

  Generated pattern matcher API of the org.eclipse.viatra.cep.core.metamodels.derived.trapState pattern, providing pattern-specific query methods.

  Use the pattern matcher on a given model via `on(ViatraQueryEngine)`, e.g. in conjunction with `ViatraQueryEngine#on(Notifier)`.

  Matches of the pattern will be represented as `TrapStateMatch`.

  Original source: ``

        @QueryBasedFeature
       pattern trapState(this : Automaton, trapState : TrapState){
              Automaton.states(this, trapState);
       }

  See Also:
    `TrapStateMatch`, `TrapStateProcessor`, `TrapStateQuerySpecification`

- - ### Field Summary

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.api.impl.BaseMatcher

      `engine, querySpecification`

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.internal.apiimpl.QueryResultWrapper

      `backend`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected TrapStateMatch` | `arrayToMatch(java.lang.Object[] match)` Converts the array representation of a pattern match to an immutable Match object.
    `protected TrapStateMatch` | `arrayToMatchMutable(java.lang.Object[] match)` Converts the array representation of a pattern match to a mutable Match object.
    `int` | `countMatches(Automaton pThis, TrapState pTrapState)` Returns the number of all matches of the pattern that conform to the given fixed values of some parameters.
    `static TrapStateMatcher` | `create()`
    `void` | `forEachMatch(Automaton pThis, TrapState pTrapState, IMatchProcessor<? super TrapStateMatch> processor)` Executes the given processor on each match of the pattern that conforms to the given fixed values of some parameters.
    `boolean` | `forOneArbitraryMatch(Automaton pThis, TrapState pTrapState, IMatchProcessor<? super TrapStateMatch> processor)` Executes the given processor on an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters.
    `java.util.Collection<TrapStateMatch>` | `getAllMatches(Automaton pThis, TrapState pTrapState)` Returns the set of all matches of the pattern that conform to the given fixed values of some parameters.
    `java.util.Set<Automaton>` | `getAllValuesOfthis()` Retrieve the set of values that occur in matches for this.
    `java.util.Set<Automaton>` | `getAllValuesOfthis(TrapState pTrapState)` Retrieve the set of values that occur in matches for this.
    `java.util.Set<Automaton>` | `getAllValuesOfthis(TrapStateMatch partialMatch)` Retrieve the set of values that occur in matches for this.
    `java.util.Set<TrapState>` | `getAllValuesOftrapState()` Retrieve the set of values that occur in matches for trapState.
    `java.util.Set<TrapState>` | `getAllValuesOftrapState(Automaton pThis)` Retrieve the set of values that occur in matches for trapState.
    `java.util.Set<TrapState>` | `getAllValuesOftrapState(TrapStateMatch partialMatch)` Retrieve the set of values that occur in matches for trapState.
    `TrapStateMatch` | `getOneArbitraryMatch(Automaton pThis, TrapState pTrapState)` Returns an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters.
    `boolean` | `hasMatch(Automaton pThis, TrapState pTrapState)` Indicates whether the given combination of specified pattern parameters constitute a valid pattern match, under any possible substitution of the unspecified parameters (if any).
    `TrapStateMatch` | `newMatch(Automaton pThis, TrapState pTrapState)` Returns a new (partial) match.
    `static TrapStateMatcher` | `on(ViatraQueryEngine engine)` Initializes the pattern matcher within an existing VIATRA Query engine.
    `static IQuerySpecification<TrapStateMatcher>` | `querySpecification()`
    `protected java.util.Set<Automaton>` | `rawAccumulateAllValuesOfthis(java.lang.Object[] parameters)` Retrieve the set of values that occur in matches for this.
    `protected java.util.Set<TrapState>` | `rawAccumulateAllValuesOftrapState(java.lang.Object[] parameters)` Retrieve the set of values that occur in matches for trapState.
    `protected TrapStateMatch` | `tupleToMatch(Tuple t)`

    - ### Methods inherited from class org.eclipse.viatra.query.runtime.api.impl.BaseMatcher

      `countMatches, countMatches, emptyArray, forEachMatch, forEachMatch, forOneArbitraryMatch, forOneArbitraryMatch, getAllMatches, getAllMatches, getAllValues, getAllValues, getCapabilities, getEngine, getOneArbitraryMatch, getOneArbitraryMatch, getParameterNames, getPatternName, getPositionOfParameter, getSpecification, hasMatch, matchToArray, newEmptyMatch, newMatch, rawAccumulateAllValues, rawCountMatches, rawForEachMatch, rawForOneArbitraryMatch, rawGetAllMatches, rawGetAllValues, rawGetOneArbitraryMatch, rawHasMatch, setBackend`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### on

          public static TrapStateMatcher on(ViatraQueryEngine engine)
                                     throws ViatraQueryException

      Initializes the pattern matcher within an existing VIATRA Query engine. If the pattern matcher is already constructed in the engine, only a light-weight reference is returned. The match set will be incrementally refreshed upon updates.
      Parameters:
        `engine` - the existing VIATRA Query engine in which this matcher will be created.
      Throws:
        `ViatraQueryException` - if an error occurs during pattern matcher creation

    - #### create

          public static TrapStateMatcher create()
                                         throws ViatraQueryException

      Returns:
        an initialized matcher
      Throws:
        `ViatraQueryException` - if an error occurs during pattern matcher creation
      No Reference:
        This method is for internal matcher initialization by the framework, do not call it manually.

    - #### getAllMatches

          public java.util.Collection<TrapStateMatch> getAllMatches(Automaton pThis,
                                                                    TrapState pTrapState)

      Returns the set of all matches of the pattern that conform to the given fixed values of some parameters.
      Parameters:
        `pThis` - the fixed value of pattern parameter this, or null if not bound.
        `pTrapState` - the fixed value of pattern parameter trapState, or null if not bound.
      Returns:
        matches represented as a TrapStateMatch object.

    - #### getOneArbitraryMatch

          public TrapStateMatch getOneArbitraryMatch(Automaton pThis,
                                                     TrapState pTrapState)

      Returns an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters. Neither determinism nor randomness of selection is guaranteed.
      Parameters:
        `pThis` - the fixed value of pattern parameter this, or null if not bound.
        `pTrapState` - the fixed value of pattern parameter trapState, or null if not bound.
      Returns:
        a match represented as a TrapStateMatch object, or null if no match is found.

    - #### hasMatch

          public boolean hasMatch(Automaton pThis,
                                  TrapState pTrapState)

      Indicates whether the given combination of specified pattern parameters constitute a valid pattern match, under any possible substitution of the unspecified parameters (if any).
      Parameters:
        `pThis` - the fixed value of pattern parameter this, or null if not bound.
        `pTrapState` - the fixed value of pattern parameter trapState, or null if not bound.
      Returns:
        true if the input is a valid (partial) match of the pattern.

    - #### countMatches

          public int countMatches(Automaton pThis,
                                  TrapState pTrapState)

      Returns the number of all matches of the pattern that conform to the given fixed values of some parameters.
      Parameters:
        `pThis` - the fixed value of pattern parameter this, or null if not bound.
        `pTrapState` - the fixed value of pattern parameter trapState, or null if not bound.
      Returns:
        the number of pattern matches found.

    - #### forEachMatch

          public void forEachMatch(Automaton pThis,
                                   TrapState pTrapState,
                                   IMatchProcessor<? super TrapStateMatch> processor)

      Executes the given processor on each match of the pattern that conforms to the given fixed values of some parameters.
      Parameters:
        `pThis` - the fixed value of pattern parameter this, or null if not bound.
        `pTrapState` - the fixed value of pattern parameter trapState, or null if not bound.
        `processor` - the action that will process each pattern match.

    - #### forOneArbitraryMatch

          public boolean forOneArbitraryMatch(Automaton pThis,
                                              TrapState pTrapState,
                                              IMatchProcessor<? super TrapStateMatch> processor)

      Executes the given processor on an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters. Neither determinism nor randomness of selection is guaranteed.
      Parameters:
        `pThis` - the fixed value of pattern parameter this, or null if not bound.
        `pTrapState` - the fixed value of pattern parameter trapState, or null if not bound.
        `processor` - the action that will process the selected match.
      Returns:
        true if the pattern has at least one match with the given parameter values, false if the processor was not invoked

    - #### newMatch

          public TrapStateMatch newMatch(Automaton pThis,
                                         TrapState pTrapState)

      Returns a new (partial) match. This can be used e.g. to call the matcher with a partial match.

      The returned match will be immutable. Use `BaseMatcher.newEmptyMatch()` to obtain a mutable match object.

      Parameters:
        `pThis` - the fixed value of pattern parameter this, or null if not bound.
        `pTrapState` - the fixed value of pattern parameter trapState, or null if not bound.
      Returns:
        the (partial) match object.

    - #### rawAccumulateAllValuesOfthis

          protected java.util.Set<Automaton> rawAccumulateAllValuesOfthis(java.lang.Object[] parameters)

      Retrieve the set of values that occur in matches for this.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfthis

          public java.util.Set<Automaton> getAllValuesOfthis()

      Retrieve the set of values that occur in matches for this.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfthis

          public java.util.Set<Automaton> getAllValuesOfthis(TrapStateMatch partialMatch)

      Retrieve the set of values that occur in matches for this.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfthis

          public java.util.Set<Automaton> getAllValuesOfthis(TrapState pTrapState)

      Retrieve the set of values that occur in matches for this.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### rawAccumulateAllValuesOftrapState

          protected java.util.Set<TrapState> rawAccumulateAllValuesOftrapState(java.lang.Object[] parameters)

      Retrieve the set of values that occur in matches for trapState.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOftrapState

          public java.util.Set<TrapState> getAllValuesOftrapState()

      Retrieve the set of values that occur in matches for trapState.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOftrapState

          public java.util.Set<TrapState> getAllValuesOftrapState(TrapStateMatch partialMatch)

      Retrieve the set of values that occur in matches for trapState.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOftrapState

          public java.util.Set<TrapState> getAllValuesOftrapState(Automaton pThis)

      Retrieve the set of values that occur in matches for trapState.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### tupleToMatch

          protected TrapStateMatch tupleToMatch(Tuple t)

      Specified by:
        `tupleToMatch` in class `BaseMatcher<TrapStateMatch>`

    - #### arrayToMatch

          protected TrapStateMatch arrayToMatch(java.lang.Object[] match)

      Description copied from class: `BaseMatcher`
      Converts the array representation of a pattern match to an immutable Match object.
      Specified by:
        `arrayToMatch` in class `BaseMatcher<TrapStateMatch>`

    - #### arrayToMatchMutable

          protected TrapStateMatch arrayToMatchMutable(java.lang.Object[] match)

      Description copied from class: `BaseMatcher`
      Converts the array representation of a pattern match to a mutable Match object.
      Specified by:
        `arrayToMatchMutable` in class `BaseMatcher<TrapStateMatch>`

    - #### querySpecification

          public static IQuerySpecification<TrapStateMatcher> querySpecification()
                                                                          throws ViatraQueryException

      Returns:
        the singleton instance of the query specification of this pattern
      Throws:
        `ViatraQueryException` - if the pattern definition could not be loaded